import React from 'react';
import { RendererProps } from '../../factory';
import { SchemaTpl } from '../../Schema';
import { CollapseSchema } from '../Collapse';
import { FormBaseControl, FormControlSchema } from './Item';
/**
 * FieldSet 表单项集合
 * 文档：https://baidu.gitee.io/amis/docs/components/form/fieldset
 */
export interface FieldSetControlSchema extends Omit<FormBaseControl, 'size'>, Omit<CollapseSchema, 'type'> {
    /**
     * 指定为表单项集合
     */
    type: 'fieldset';
    /**
     * 表单项集合
     */
    controls?: Array<FormControlSchema>;
    /**
     * 标题
     */
    title?: SchemaTpl;
}
export interface FieldSetProps extends RendererProps, Omit<FieldSetControlSchema, 'type'> {
}
export default class FieldSetControl extends React.Component<FieldSetProps, any> {
    constructor(props: FieldSetProps);
    static defaultProps: {
        headingClassName: string;
        collapsable: boolean;
    };
    renderBody(): JSX.Element;
    render(): JSX.Element;
}
export declare class FieldSetRenderer extends FieldSetControl {
}
