import React from 'react';
import { OptionsControlProps, Option, FormOptionsControl } from './Options';
import { Api } from '../../types';
import { SchemaApi } from '../../Schema';
/**
 * Select 下拉选择框。
 * 文档：https://baidu.gitee.io/amis/docs/components/form/select
 */
export interface SelectControlSchema extends FormOptionsControl {
    type: 'select' | 'multi-select';
    /**
     * 自动完成接口，请不要跟 source 同时使用。
     */
    autoComplete?: SchemaApi;
    /**
     * 是否可以搜索值
     */
    searchable?: boolean;
}
export interface SelectProps extends OptionsControlProps {
    autoComplete?: Api;
    searchable?: boolean;
    defaultOpen?: boolean;
}
export default class SelectControl extends React.Component<SelectProps, any> {
    static defaultProps: Partial<SelectProps>;
    input: any;
    unHook: Function;
    constructor(props: SelectProps);
    componentWillUnmount(): void;
    inputRef(ref: any): void;
    foucs(): void;
    changeValue(value: Option | Array<Option> | void): void;
    loadRemote(input: string): (() => void) | Promise<{
        options: object[];
    }>;
    mergeOptions(options: Array<object>): object[];
    reload(): void;
    render(): JSX.Element;
}
export declare class SelectControlRenderer extends SelectControl {
}
export declare class MultiSelectControlRenderer extends SelectControl {
    static defaultProps: {
        multiple: boolean;
    };
}
