import React from 'react';
import { FormControlProps, FormBaseControl } from './Item';
import { TableCell } from '../Table';
import { SchemaTpl } from '../../Schema';
/**
 * Static
 * 文档：https://baidu.gitee.io/amis/docs/components/form/static
 */
export interface StaticControlSchema extends FormBaseControl {
    type: 'static';
    /**
     * 内容模板， 支持 HTML
     */
    tpl?: SchemaTpl;
    /**
     * 内容模板，不支持 HTML
     */
    text?: SchemaTpl;
}
export interface StaticProps extends FormControlProps {
    placeholder?: string;
    tpl?: string;
    text?: string;
}
export default class StaticControl extends React.Component<StaticProps, any> {
    static defaultProps: {
        placeholder: string;
    };
    constructor(props: StaticProps);
    handleQuickChange(values: any, saveImmediately: boolean | any): void;
    render(): JSX.Element;
}
export declare class StaticControlRenderer extends StaticControl {
}
export declare class StaticFieldRenderer extends TableCell {
    static defaultProps: {
        wrapperComponent: string;
    };
    render(): JSX.Element;
}
