import React from 'react';
import { FormControlProps, FormBaseControl } from './Item';
/**
 * Static
 * 文档：https://baidu.gitee.io/amis/docs/components/form/static
 */
export interface SubFormControlSchema extends FormBaseControl {
    type: 'form';
    /**
     * 占位符
     */
    placeholder?: string;
    /**
     * 是否多选
     */
    multiple?: boolean;
    /**
     * 最少个数
     */
    minLength?: number;
    /**
     * 最多个数
     */
    maxLength?: number;
    /**
     * 按钮名称字段。
     */
    labelField?: string;
}
export interface SubFormProps extends FormControlProps {
    placeholder?: string;
    multiple?: boolean;
    minLength?: number;
    maxLength?: number;
    labelField?: string;
}
export interface SubFormState {
    openedIndex: number;
    optionIndex: number;
}
export default class SubFormControl extends React.PureComponent<SubFormProps, SubFormState> {
    static defaultProps: Partial<SubFormProps>;
    state: SubFormState;
    constructor(props: SubFormProps);
    addItem(): void;
    removeItem(key: number, e: React.UIEvent<any>): void;
    open(index?: number): void;
    close(): void;
    handleDialogConfirm(values: Array<object>): void;
    buildDialogSchema(): {
        type: string;
        body: {
            type: string;
        };
    };
    renderMultipe(): JSX.Element[];
    renderSingle(): JSX.Element;
    render(): JSX.Element;
}
export declare class SubFormControlRenderer extends SubFormControl {
}
