import React from 'react';
import { RendererProps } from '../factory';
import { BaseSchema, SchemaTpl } from '../Schema';
/**
 * Mapping 映射展示控件。
 * 文档：https://baidu.gitee.io/amis/docs/components/mapping
 */
export interface MappingSchema extends BaseSchema {
    type: 'map' | 'mapping';
    /**
     * 关联字段名。
     */
    name?: string;
    map?: {
        '*': SchemaTpl;
        [propName: string]: SchemaTpl;
    };
    /**
     * 占位符
     */
    placeholder?: string;
}
export interface MappingProps extends RendererProps, MappingSchema {
}
export declare class MappingField extends React.Component<MappingProps, object> {
    static defaultProps: Partial<MappingProps>;
    render(): JSX.Element;
}
export declare class MappingFieldRenderer extends MappingField {
}
